import logging
import os

from lunavl.sdk.image_utils.image import MemoryResidence, VLImage  # isort: split
import PyNvCodec as nvc  # isort: split

# required to save import order to some PyNvCodeс peculiarities
__all__ = ["MemoryResidence", "VLImage", "nvc"]

logger = logging.getLogger(__file__)

if os.name == "nt":
    # Add CUDA_PATH env variable
    cuda_path = os.environ["CUDA_PATH"]
    if cuda_path:
        os.add_dll_directory(cuda_path)  # type: ignore
    else:
        logger.error("CUDA_PATH environment variable is not set.")
        logger.error("Can't set CUDA DLLs search path.")
        exit(1)

    # Add PATH as well for minor CUDA releases
    sys_path = os.environ["PATH"]
    if sys_path:
        paths = sys_path.split(";")
        for path in paths:
            if os.path.isdir(path):
                os.add_dll_directory(path)  # type: ignore
    else:
        logger.error("PATH environment variable is not set.")
        exit(1)
