import asyncio
from typing import Any

from . import logger
from .monitoring import FRAMES_MONITORING as FM


class DecodeQueue(asyncio.Queue):
    """Stream Decode Frames Queue"""

    stopObj = None

    def __init__(self, maxsize=0, useMonitoring: bool = False, useLogger: bool = False):
        super().__init__(maxsize=maxsize)
        self.useMonitoring = useMonitoring
        self.useLogger = useLogger

    async def putWithShift(self, item: Any) -> None:
        FM.countFrame()
        if self.full():
            self.get_nowait()
            if self.useMonitoring:
                FM.skipFrame()
            if self.useLogger:
                logger.warning("skip frame, decoded frames queue is full")
        self.put_nowait(item)

    def stop(self):
        """Stop queue, by adding stop item == None"""
        self.putWithShift(self.stopObj)
