from enum import Enum


class VideoSource(Enum):
    """Video source enum"""

    file = "file"  # finite video file
    stream = "stream"  # infinite video stream


class PTSPolicy(Enum):
    """Enum for pts source"""

    server = "server"
    pts = "pts"
    frameRate = "frame_rate"
    auto = "auto"


class DeviceClass(Enum):
    # automatically switch to cpu if gpu it can't perform decoding
    auto = "auto"
    # use cpu
    cpu = "cpu"
    # use gpu
    gpu = "gpu"


class DecoderState(Enum):
    """Decoder internal state"""

    # decoder only initiated
    initiated = 1
    # decoder only initiated + prepared to work
    prepared = 2
    # decoding in progress
    decoding = 3
    # decoding completed
    completed = 4
    # error
    error = 5
    # interrupted
    interrupted = 6
    # scheduled to stop
    stoping = 7


class ErrorAction(Enum):
    """Error action enum"""

    fail = 1  # raise error
    stop = 2  # graceful stop decoding
    reconnect = 3  # reconnect to stream (only for live stream)


class OrientationStrategy(Enum):
    """Orientation strategy"""

    videoInfo = "video_info"
    static = "static"
