from typing import NamedTuple

from lunavl.sdk.image_utils.image import RotationAngle, VLImage


class VideoData(NamedTuple):
    """Container for decoded frames"""

    # bytes of the image
    buffer: VLImage
    # frame number
    number: int
    # frame offset
    timestamp: float
    # marker that the frame is last
    lastFrame: bool


class VideoSegment(NamedTuple):
    """Video segment container"""

    startOffset: float  # start segment time (timestamp)
    endOffset: float  # end segment time (timestamp)


ORIENTATION_MAP = {
    0: RotationAngle.ANGLE_0,
    90: RotationAngle.ANGLE_90,
    180: RotationAngle.ANGLE_180,
    270: RotationAngle.ANGLE_270,
}
